
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>socket跟TCP/IP 的关系,单台服务器上的并发TCP连接数可以有多少 / 憋错料</title>

    <meta name="description" content="socket跟TCP/IP 的关系,单台服务器上的并发TCP连接数可以有多少 常识一:文件句柄限制 在linux下编写网络服务器程序的朋友肯定都知道每一个tcp连接都要占一个文件描述符,一旦这个文件描述符使用完了,新的连接到来返回给我们的错误是“Socket/File:Can'topen so many files”. 这时你需要明白操作系统对可以打开的最大文件数的限制. 进程限制 执行ulimit -n 输出1024,说明对于一个进程而言最多只能打开1024个文件,所以你要采用此默认配置最多也就可以并发上千个TCP连接. 临时修改:ulimit -n1000000,但是">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">socket跟TCP/IP 的关系,单台服务器上的并发TCP连接数可以有多少</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h3>常识一：文件句柄限制</h3>
<p>在linux下编写网络服务器程序的朋友肯定都知道每一个tcp连接都要占一个文件描述符，一旦这个文件描述符使用完了，新的连接到来返回给我们的错误是<strong>&ldquo;Socket/File:Can‘topen so many files&rdquo;</strong>。</p>
<p>这时你需要明白操作系统对可以打开的最大文件数的限制。</p>
<ul>
<li>进程限制</p>
<ul>
<li>执行ulimit -n 输出1024，说明对于一个进程而言最多只能打开1024个文件，所以你要采用此默认配置最多也就可以并发上千个TCP连接。</li>
<li>临时修改：ulimit -n1000000，但是这种临时修改只对当前登录用户目前的使用环境有效，系统重启或用户退出后就会失效。</li>
<li>永久修改：编辑/etc/security/limits.conf 文件， 修改后内容为
<p><code>* soft nofile 1000000</code></p>
<p><code>* hard nofile 1000000</code></li>
</ul>
</li>
<li>全局限制
<ul>
<li>执行 cat/proc/sys/fs/file-nr 输出<code>9344 0592026</code>，分别为：1.已经分配的文件句柄数，2.已经分配但没有使用的文件句柄数，3.最大文件句柄数。但在kernel2.6版本中第二项的值总为0，这并不是一个错误，它实际上意味着已经分配的文件描述符无一浪费的都已经被使用了 。</li>
<li>我们可以把这个数值改大些，用 root 权限修改 /etc/sysctl.conf 文件:
<p><code>fs.file-max = 1000000</code></p>
<p><code>net.ipv4.ip_conntrack_max = 1000000</code></p>
<p><code>net.ipv4.netfilter.ip_conntrack_max = 1000000</code></li>
</ul>
</li>
</ul>
<h3>常识二：端口号范围限制？</h3>
<p>操作系统上端口号1024以下是系统保留的，从1024-65535是用户使用的。由于每个TCP连接都要占一个端口号，所以我们最多可以有60000多个并发连接。我想有这种错误思路朋友不在少数吧？（其中我过去就一直这么认为）</p>
<p>我们来分析一下吧</p>
<ul>
<li>如何标识一个TCP连接：系统用一个4四元组来唯一标识一个TCP连接：{local ip, local port,remoteip,remoteport}。好吧，我们拿出《UNIX网络编程：卷一》第四章中对accept的讲解来看看概念性的东西，第二个参数cliaddr代表了客户端的ip地址和端口号。而我们作为服务端实际只使用了bind时这一个端口，说明端口号65535并不是并发量的限制。</li>
<li>server最大tcp连接数：server通常固定在某个本地端口上监听，等待client的连接请求。不考虑地址重用（unix的SO_REUSEADDR选项）的情况下，即使server端有多个ip，本地监听端口也是独占的，因此server端tcp连接4元组中只有remoteip（也就是client ip）和remoteport（客户端port）是可变的，因此最大tcp连接为客户端ip数&times;客户端port数，对IPV4，不考虑ip地址分类等因素，最大tcp连接数约为2的32次方（ip数）&times;2的16次方（port数），也就是server端单机最大tcp连接数约为2的48次方。</li>
</ul>
<p>要写网络程序就必须用Socket，这是程序员都知道的。而且，面试的时候，我们也会问对方会不会Socket编程？一般来说，很多人都会说，Socket编程基本就是listen，accept以及send，write等几个基本的操作。是的，就跟常见的文件操作一样，只要写过就一定知道。</p>
<p>对于网络编程，我们也言必称TCP/IP，似乎其它网络协议已经不存在了。对于TCP/IP，我们还知道TCP和UDP，前者可以保证数据的正确和可靠性，后者则允许数据丢失。最后，我们还知道，在建立连接前，必须知道对方的IP地址和端口号。除此，普通的程序员就不会知道太多了，很多时候这些知识已经够用了。最多，写服务程序的时候，会使用多线程来处理并发访问。</p>
<p>我们还知道如下几个事实：</p>
<p>1。一个指定的端口号不能被多个程序共用。比如，如果IIS占用了80端口，那么Apache就不能也用80端口了。</p>
<p>2。很多防火墙只允许特定目标端口的数据包通过。</p>
<p>3。服务程序在listen某个端口并accept某个连接请求后，会生成一个新的socket来对该请求进行处理。</p>
<p>于是，一个困惑了我很久的问题就产生了。如果一个socket创建后并与80端口绑定后，是否就意味着该socket占用了80端口呢？如果是这样的，那么当其accept一个请求后，生成的新的socket到底使用的是什么端口呢（我一直以为系统会默认给其分配一个空闲的端口号）？如果是一个空闲的端口，那一定不是80端口了，于是以后的TCP数据包的目标端口就不是80了--防火墙一定会组织其通过的！实际上，我们可以看到，防火墙并没有阻止这样的连接，而且这是最常见的连接请求和处理方式。我的不解就是，为什么防火墙没有阻止这样的连接？它是如何判定那条连接是因为connet80端口而生成的？是不是TCP数据包里有什么特别的标志？或者防火墙记住了什么东西？</p>
<p>后来，我又仔细研读了TCP/IP的协议栈的原理，对很多概念有了更深刻的认识。比如，在TCP和UDP同属于传输层，共同架设在IP层（网络层）之上。而IP层主要负责的是在节点之间（End</p>
<p>to&nbsp;End）的数据包传送，这里的节点是一台网络设备，比如计算机。因为IP层只负责把数据送到节点，而不能区分上面的不同应用，所以TCP和UDP协议在其基础上加入了端口的信息，端口于是标识的是一个节点上的一个应用。除了增加端口信息，UPD协议基本就没有对IP层的数据进行任何的处理了。而TCP协议还加入了更加复杂的传输控制，比如滑动的数据发送窗口（Slice&nbsp;Window），以及接收确认和重发机制，以达到数据的可靠传送。不管应用层看到的是怎样一个稳定的TCP数据流，下面传送的都是一个个的IP数据包，需要由TCP协议来进行数据重组。</p>
<p>所以，我有理由怀疑，防火墙并没有足够的信息判断TCP数据包的更多信息，除了IP地址和端口号。而且，我们也看到，所谓的端口，是为了区分不同的应用的，以在不同的IP包来到的时候能够正确转发。</p>
<p>TCP/IP只是一个协议栈，就像操作系统的运行机制一样，必须要具体实现，同时还要提供对外的操作接口。就像操作系统会提供标准的编程接口，比如Win32编程接口一样，TCP/IP也必须对外提供编程接口，这就是Socket编程接口--原来是这么回事啊！</p>
<p>在Socket编程接口里，设计者提出了一个很重要的概念，那就是socket。这个socket跟文件句柄很相似，实际上在BSD系统里就是跟文件句柄一样存放在一样的进程句柄表里。这个socket其实是一个序号，表示其在句柄表中的位置。这一点，我们已经见过很多了，比如文件句柄，窗口句柄等等。这些句柄，其实是代表了系统中的某些特定的对象，用于在各种函数中作为参数传入，以对特定的对象进行操作--这其实是C语言的问题，在C++语言里，这个句柄其实就是this指针，实际就是对象指针啦。</p>
<p>现在我们知道，socket跟TCP/IP并没有必然的联系。Socket编程接口在设计的时候，就希望也能适应其他的网络协议。所以，socket的出现只是可以更方便的使用TCP/IP协议栈而已，其对TCP/IP进行了抽象，形成了几个最基本的函数接口。比如create，listen，accept，connect，read和write等等。</p>
<p>现在我们明白，如果一个程序创建了一个socket，并让其监听80端口，其实是向TCP/IP协议栈声明了其对80端口的占有。以后，所有目标是80端口的TCP数据包都会转发给该程序（这里的程序，因为使用的是Socket编程接口，所以首先由Socket层来处理）。所谓accept函数，其实抽象的是TCP的连接建立过程。accept函数返回的新socket其实指代的是本次创建的连接，而一个连接是包括两部分信息的，一个是源IP和源端口，另一个是宿IP和宿端口。所以，accept可以产生多个不同的socket，而这些socket里包含的宿IP和宿端口是不变的，变化的只是源IP和源端口。这样的话，这些socket宿端口就可以都是80，而Socket层还是能根据源/宿对来准确地分辨出IP包和socket的归属关系，从而完成对TCP/IP协议的操作封装！而同时，放火墙的对IP包的处理规则也是清晰明了，不存在前面设想的种种复杂的情形。</p>
<p>明白socket只是对TCP/IP协议栈操作的抽象，而不是简单的映射关系，这很重要！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-12 12:00:27 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e4%b8%a2%e5%a4%b1/" title="丢失">丢失</a>, <a href="https://www.biecuoliao.com/tag/tar/" title="tar">tar</a>, <a href="https://www.biecuoliao.com/tag/%e5%8e%9f%e7%90%86/" title="原理">原理</a>, <a href="https://www.biecuoliao.com/tag/%e5%88%86%e6%9e%90/" title="分析">分析</a>, <a href="https://www.biecuoliao.com/tag/%e8%8c%83%e5%9b%b4/" title="范围">范围</a>, <a href="https://www.biecuoliao.com/tag/%e8%80%8c%e4%b8%94/" title="而且">而且</a>, <a href="https://www.biecuoliao.com/tag/%e7%81%ab%e5%a2%99/" title="火墙">火墙</a>, <a href="https://www.biecuoliao.com/tag/local/" title="local">local</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%87%e4%bb%b6%e6%93%8d%e4%bd%9c/" title="文件操作">文件操作</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>socket跟TCP/IP 的关系,单台服务器上的并发TCP连接数可以有多少的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZYwYL0.html" rel="bookmark">网络编程释疑之：单台服务器上的并发TCP连接数可以有多少</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				曾几何时我们还在寻求网络编程中C10K问题的解决方案,但是现在从硬件和操作系统支持来看单台服务器支持上万并发连接已经没有多少挑战性了.我们先假设单台服务器最多只能支持万级并发连接,其实对绝大多数应用来说已经远远足够了,但是对于一些拥有很大用户基数的互联网公司,往往面临的并发连接数是百万,千万,甚至腾讯的上亿(注:QQ默认用的UDP协议).虽然现在的集群,分布式技术可以为我们将并发负载分担在多台服务器上,那我们只需要扩展出数十台电脑就可以解决问题,但是我们更希望能更大的挖掘单台服务器的资源,先努力			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n4AbAbM.html" rel="bookmark">【 Linux 】单台服务器上并发TCP连接数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				单台服务器上并发TCP连接数    问题:一台服务器到底能够支持多少TCP并发连接呢? 1. 文件描述符限制:    对于服务器来说,每一个TCP连接都要占用一个文件描述符,一旦文件描述符使用完,新的连接到来返回给我们的错误是&quot;Socket/File:Can't open so many files&quot; 这时,你需要明白操作系统可以打开最大文件数的限制. 进程限制(用户限制):            执行 ulimit -n 输出1024,说明对于一个进程而言最多只能打开1024个文件,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEqWDKM.html" rel="bookmark">centos7在单台服务器上安装FastDFS的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				准备环境: #安装依赖包 yum -y install gcc gcc-c++ libtool pcre* zlib openssl openssl-devel mkdir /FastDFS/ #上传下载工具 yum -y install lrzsz yum -y install unzip cd /FastDFS/ 上传fastdfs-dep.zip rz #安装libfastcommon cd /FastDFS/ unzip fastdfs-dep.zip cd /FastDFS/fastd			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dnRZ94.html" rel="bookmark">在单台服务器上搭建elasticsearch集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				很遗憾,这样的集群基本上没啥用处,没有容错能力.因此本文仅可作为学习ES集群部署的参考文档. 系统配置: 修改/etc/hosts增加 127.0.0.1 node01 127.0.0.1 node02 127.0.0.1 node03 修改/etc/sysctl.conf增加配置,然后执行sysctl -p立即生效 vm.max_map_count=655360 用到的软件包: elasticsearch-6.8.6.tar.gz kibana-6.8.6-linux-x86_64.tar.g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3v69g93.html" rel="bookmark">高性能网络编程&lpar;一&rpar;：单台服务器并发TCP连接数到底可以有多少</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阅读(81374) | 评论(9)收藏16 淘帖1 赞3 JackJiang Lv.9    1 年前 | 前言 曾几何时我们还在寻求网络编程中C10K问题(有关C10K问题请见文章&lt;The C10K problem(英文在线阅读.英文PDF版下载.中文译文)&gt;)的解决方案,但是现在从硬件和操作系统支持来看单台服务器支持上万并发连接已经没有多少挑战性了. 我们先假设单台服务器最多只能支持万级并发连接,其实对绝大多数应用来说已经远远足够了,但是对于一些拥有很大用户基数的互联网公司,往往面临的并发			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wLg914.html" rel="bookmark">单台服务器最大tcp连接</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果对服务器进行压力测试,常常出现这种情况 tcp连接数过多 netstat   -an    windows查看tcp连接数 那么怎么增加单台服务器的最大连接数呢?       最简单的办法,增加内存,socket连接大概10多kb一个 详情   https://www.cnblogs.com/duanxz/p/4464178.html 原文地址:https://www.cnblogs.com/a1304908180/p/10606551.html			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEWr5P3.html" rel="bookmark">单台服务器并发百万级配置&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				单台服务器并发百万级配置(转) 目的:让服务器支持大量并发访问. 注:以下内容 ASP/ASP.NET IIS 用不成.另外要精通Linux,TCP/IP. 摘要:本文主要介绍利用单台PC服务器来实现可支持百万级用户并发访问的WEB服务器的实践工作.意在提出一些手段来发掘设备的潜力,充分利用设备资源,以求达到降低硬件投入成本和维护成本的目的. 随着硬件技术的飞速发展,当前单台PC 服务器的性能得到了显著提升,反之,硬件成本却在快速下降.另一方面,多数门户网站.大型社区在建设WEB服务.邮件服务等			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49Wprg0.html" rel="bookmark">单台电脑上启动多个Modelsim图形环境窗口的简单办法（windows）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 http://blog.21ic.com/user1/3128/archives/2010/73447.html 单台电脑上启动多个Modelsim图形环境窗口的简单办法(windows) Modelsim由于License限制,一般一个PC机只能启动一个窗口程序,打开第二个时候就会出错退出,很不方便调试使用.后来发现,结合一个叫zDesk的软件使用可以很好的解决这个问题.这个软件有点像linux下的多窗口,切换到第二个窗口下,就可以打开一个新的Modelsim图形环境.软件可以启动很多个窗			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nXEep4.html" rel="bookmark">在单台主机上配置LNMP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在单台主机上配置LNMP 编译安装nginx 1.登录官网获取下载链接直接wget [[email protected] ~]# wget http://nginx.org/download/nginx-1.17.0.tar.gz 2.解压文件 [[email protected] ~]# tar xf nginx-1.17.0.tar.gz 3.检查当前环境是否符合编译要求,并生成makefile文件 [[email protected] ~]# cd nginx-1.17.0 [[email			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/N4pQWKM.html" rel="bookmark" class="title">LeetCode 21 Merge Two Sorted Lists</a>
					<div>
						翻译 合并两个排好序的链表,并返回这个新链表. 新链表应该由这两个链表的头部拼接而成. 原文 Merge two sorted linked lists and return it as a new  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pvpeP0.html" rel="bookmark" class="title">循环-01&period; 求整数段和&lpar;15&rpar;</a>
					<div>
						给定两个整数A和B,输出从A到B的所有整数以及这些数的和. 输入格式: 输入在一行中给出2个整数A和B,其中-100&lt;=A&lt;=B&lt;=100,其间以空格分隔. 输出格式: 首先顺序输出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDlzdM.html" rel="bookmark" class="title">Webstorm10注册码</a>
					<div>
						分享几个WS10的注册码: (1) user name :EMBRACE ===== LICENSE BEGIN =====17739-1204201000002KkN!4z2O8JEyjkuftDA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8qgz0.html" rel="bookmark" class="title">Asp&period;net Vnext   &amp;amp&semi; MVC6  系列</a>
					<div>
						vs 2015  rc  vnext  1.0.0-beta4 ,本系列还将持续继续更新 Asp.net Vnext 调试源码 Asp.net Vnext 自定义日志 Asp.net Vnext 中间 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02L2va4.html" rel="bookmark" class="title">Java编码 蛇形矩阵的构建与遍历输出</a>
					<div>
						一.蛇形矩阵的构建,并按行输出 例: 输入:n, 生成n*n的蛇形矩阵 1 2 3 8 9 4 7 6 5 输出:1 2 3 8 9 4 7 6 5 java编码 public static void ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME8x1Z4.html" rel="bookmark" class="title">机器的智慧</a>
					<div>
						一:什么是智慧 有人说,智慧就是选择,当你遇到难题的时候,选择那条路,找到解决问题的办法,就是智慧的体现,不无道理. 二:机器有智慧吗? 工具的进化有三个阶段: 传统的工具是没有智慧的?比如锤子,只有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDvK8k3.html" rel="bookmark" class="title">Palindromes &lowbar;easy version（hdu2029）</a>
					<div>
						输入格式:首先一个整型,然后循环不带空格未知长度的字符串. 思考:首先用scanf_s()输入整型,然后一个大循环,用gets_s()函数输入字符串. 注意:scanf_s()多加了一个%c,&amp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41BYgJM.html" rel="bookmark" class="title">几种流形学习算法-转载</a>
					<div>
						标签: 知识/探索 流形 分类: technic 局部线性嵌入(LLE) 等距映射(Isomap) 拉普拉斯特征映射(Laplacian Eigenmap) 局部线性嵌入(LLE) 前提假设:采样数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bq1VvM.html" rel="bookmark" class="title">vsftpd 流行ftp配置记录说明</a>
					<div>
						vsftpd per-IP方式配置: 需要启用vsftpd的tcp_wrappers集成功能,从版本1.1.3开始支持. 编译时修改builddefs.h文件,将#undef VSF_BUILD_TC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R7Db73.html" rel="bookmark" class="title">屏幕自适应宽度</a>
					<div>
						移动设备正超过桌面设备,成为访问互联网的最常见终端.于是,网页设计师不得不面对一个难题:如何才能在不同大小的设备上呈现同样的网页? 很多网站的解决方法,是为不同的设备提供不同的网页,比如专门提供一个m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q7Lnw0.html" rel="bookmark" class="title">美国会议签证&mdash;&mdash;我是正当理由去美国，我能支付（或有人为我支付）我在美国期间的所有费用，办完事我肯定回来， 邀请信&comma;行程表这些材料齐全即可</a>
					<div>
						急!有去美国参加会议签证经验的请进啊~~~~ hiki 来自签证版问题 5月从英国想去参加个会议,因为以前被拒过,这次特紧张 签过的xdjm能分享下经验嘛?除了网站上要的材料,还需要别的嘛? 谢谢大家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MymqwjM.html" rel="bookmark" class="title">树状数组模板1（例题洛谷P3374）（单点修改&plus;区间查询）</a>
					<div>
						例题:https://www.luogu.org/problem/show?pid=3374 程序: #include&lt;iostream&gt; #include&lt;cstdio&gt; # ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nLnXV4.html" rel="bookmark" class="title">iOS&mdash;请求Web Service</a>
					<div>
						1.iOS SDK 同步GET请求 NSString *strURL = [[NSString alloc] initWithFormat:@&quot;http://www.51work6.com/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDNv2K3.html" rel="bookmark" class="title">SHELL脚本攻略（学习笔记）--1&period;2 echo和printf打印输出</a>
					<div>
						1.2.1 echo的引号问题 关于echo的用法,注意点就是单引号和双引号的特殊情况.以打印“Hello World!”为例. [[email protected] tmp]# echo Hello ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qGlO7M.html" rel="bookmark" class="title">erlang进程与操作系统线程</a>
					<div>
						erlang多进程与多线程: 在erlang开发中,我们面对的最小执行单位是进程,当然这个进程并不是系统层面上的进程,也不是线程.而是基于erlang运行时系统的一个进程.那么erlang的多进程是如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Op7A74.html" rel="bookmark" class="title">0x7FFFFFFF</a>
					<div>
						可以算一下 0x7FFFFFFF 是多少 每个十六进制数4bit,因此8位16进制是4个字节,刚好是一个int整型 F的二进制码为 1111 7的二进制码为 0111 这样一来,整个整数 0x7FFF ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QoaXw0.html" rel="bookmark" class="title">1806&colon; &lbrack;Ioi2007&rsqb;Miners 矿工配餐</a>
					<div>
						1806: [Ioi2007]Miners 矿工配餐 Description 现有两个煤矿,每个煤矿都雇用一组矿工.采煤工作很辛苦,所以矿工们需要良好饮食.每当一辆食品车到达煤矿时,矿工们便会产出一定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kljrX3.html" rel="bookmark" class="title">《linux下进程的创建，执行，监控和终止》</a>
					<div>
						http://blog.csdn.net/miss_acha/article/details/43671047 http://blog.csdn.net/rosekin/article/details ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzXARy3.html" rel="bookmark" class="title">Eclipse开发Android，Java项目快捷键技巧</a>
					<div>
						工欲善其事必先利其器,在IDE中开发软件很重要的一个步骤就是快捷键的设置,设置了自己最熟悉的快捷键,开发效率将会大大提升.该篇帖子说说我的Eclipse快捷键设置.我常用的Eclipse快捷键如下:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVRoEdM.html" rel="bookmark" class="title">Elasticsearch 5&period;4&period;3实战--Java API调用：搜索</a>
					<div>
						ES有多种查询方式,我自己的业务是需要对多个字段进行查询,具体实现类代码如下. 1 package com.cs99lzzs.elasticsearch.service.imp; 2 3 import ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
